#include <curl/curl.h>
#include <curl/easy.h>
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>
#include <bsd/md5.h>

int main()
{
  void *curl;
  uint8_t data[] = { 'H', 'e', 'l', 'l', 'o', '!' };
  uint8_t md[MD5_DIGEST_LENGTH];
  MD5_CTX ctx;

  MD5Init(&ctx);
  MD5Update(&ctx, data, sizeof(data));
  MD5Final(md, &ctx);

  curl = curl_easy_init();
  curl_easy_setopt(curl, CURLOPT_VERBOSE, true);
  curl_easy_setopt(curl, CURLOPT_HTTP_VERSION , CURL_HTTP_VERSION_1_1);
  curl_easy_setopt(curl, CURLOPT_URL, "http://localhost/debug.php");
  curl_easy_setopt(curl, CURLOPT_POST, true);
  curl_easy_setopt(curl, CURLOPT_POSTFIELDS, data);
  curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, sizeof(data));
  curl_easy_setopt(curl, CURLOPT_CONTENTHASH, md);
  curl_easy_setopt(curl, CURLOPT_CONTENTHASH_FORMAT, "MD5");
  curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, fwrite);
  curl_easy_setopt(curl, CURLOPT_WRITEDATA, stdout);
  curl_easy_perform(curl);

  return 0;
}
